﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.IO;
using System.Threading;
using System.Timers;

namespace JewelsHraProHrace
{
    public partial class Form1 : Form
    {
        string File = "";
        int[,] tabulka = new int[8, 8], doplnovaci = new int[8, 1025];
        int[] poziceDopnovaci = { 0, 0, 0, 0, 0, 0, 0, 0 };
        const int stoneSize = 50;
        bool casovyLimit = false, clik1 = true, start = false, nechStarouTabulku = false;
        int kamen1X = 0, kamen2X = 0, kamen1Y = 0, kamen2Y = 0, celkoveBody = 0;
        static int time = 0;

        public Form1()
        {
            InitializeComponent();
        }

        private Color IntToColor(int N)
        {
            Color c = Color.Black;
            switch(N)
            {
                case 1: c = Color.Red; break;
                case 2: c = Color.Green; break;
                case 3: c = Color.Blue; break;
                case 4: c = Color.White; break;
                case 5: c = Color.Yellow; break;
                case 6: c = Color.Purple; break;
            }
            return c;
        }
        

        private Color IntToDarkColor(int N)
        {
            Color c = Color.Black;
            switch (N)
            {
                case 1: c = Color.DarkRed; break;
                case 2: c = Color.DarkGreen; break;
                case 3: c = Color.DarkBlue; break;
                case 4: c = Color.Gray; break;
                case 5: c = Color.Orange; break;
                case 6: c = Color.Pink; break;
            }
            return c;
        }

        private void Form1_MouseMove(object sender, MouseEventArgs e)
        {
            LBbody.Text = celkoveBody.ToString();
            NacteniPlochy(null, null);

            NUPmin.Value = (time / 1000) - (time / 1000) % 60;
            NUPsec.Value = (time / 1000) % 60;


            if (clik1 == false)
            {
                Graphics g = this.CreateGraphics();
                g.FillEllipse(new SolidBrush(IntToDarkColor(tabulka[kamen1X, kamen1Y])), (kamen1X + 2) * stoneSize, (kamen1Y + 2) * stoneSize, stoneSize - 2, stoneSize - 2);
                g.DrawEllipse(Pens.Black, (kamen1X + 2) * stoneSize, (kamen1Y + 2) * stoneSize, stoneSize - 2, stoneSize - 2);
            }
        }

        private void NacteniPlochy(object sender, EventArgs e)
        {
            Graphics g = this.CreateGraphics();
            Pen p = new Pen(Color.Black);
            Brush b;
            for (int x = 0; x < 8; x++)
            {
                for (int y = 0; y < 8; y++)
                {
                    g.FillEllipse(new SolidBrush(IntToColor(tabulka[x, y])), (x + 2) * stoneSize, (y + 2) * stoneSize, stoneSize - 2, stoneSize - 2);
                    g.DrawEllipse(p, (x + 2) * stoneSize, (y + 2) * stoneSize, stoneSize - 2, stoneSize - 2);
                }
            }

            for(int i = 0;i<8;i++)
            {
                g.FillEllipse(new SolidBrush(IntToColor(doplnovaci[i, poziceDopnovaci[i]])), (i + 2) * stoneSize, 0, stoneSize - 2, stoneSize - 2);
                g.DrawEllipse(p, (i + 2) * stoneSize, 0, stoneSize - 2, stoneSize - 2);

            }
        }

        private void BTstart_Click(object sender, EventArgs e)
        {
            NUPmin.ReadOnly = true;
            NUPsec.ReadOnly = true;

            if (casovyLimit == false)
            {
                start = true;
            }
            else
            {
                start = true;
                System.Timers.Timer aTimer = new System.Timers.Timer();
                aTimer.Elapsed += new ElapsedEventHandler(OnTimedEvent);
                aTimer.Interval = ((int)NUPmin.Value*60 + (int)NUPsec.Value) * 1000;
                aTimer.Enabled = true;
                time = ((int)NUPmin.Value * 60 + (int)NUPsec.Value) * 1000;


                System.Timers.Timer aTimer2 = new System.Timers.Timer();
                aTimer.Elapsed += new ElapsedEventHandler(OnTimedEvent2);
                aTimer.Interval = 1000;
                aTimer.Enabled = true;
            }
        }

        private void Form1_MouseClick(object sender, MouseEventArgs e)
        {
            int body = 0;
            if (e.X < stoneSize * 2 || e.Y < stoneSize * 2 || e.X > stoneSize * 10 || e.Y > stoneSize * 10) return;

            if (start == false) { MessageBox.Show("První musíte hru spustit tlačítkem START"); return; }

            int x, y;
            x = (e.X - (2 * stoneSize)) / stoneSize;
            y = (e.Y - (2 * stoneSize)) / stoneSize;
            if(clik1)
            {
                Graphics g = this.CreateGraphics();
                g.FillEllipse(new SolidBrush(IntToDarkColor(tabulka[x, y])), (x + 2) * stoneSize, (y + 2) * stoneSize, stoneSize - 2, stoneSize - 2);
                g.DrawEllipse(Pens.Black, (x + 2) * stoneSize, (y + 2) * stoneSize, stoneSize - 2, stoneSize - 2);
                kamen1X = x;
                kamen1Y = y;
                clik1 = false;
            }
            else
            {
                kamen2X = x;
                kamen2Y = y;

                if (kamen1X == kamen2X + 1 || kamen1X == kamen2X - 1 || kamen1Y == kamen2Y + 1 || kamen1Y == kamen2Y - 1)
                {
                    if (((kamen1X == kamen2X + 1 || kamen1X == kamen2X - 1) && (kamen1Y == kamen2Y + 1 || kamen1Y == kamen2Y - 1)) == false) //pokud podminka neni splnena jsou uhlopricne
                    {

                        for (int i = 0; i < 50; i++) // pro detekci vsech sledu
                        {
                            body = VyhodnotTah();
                            PosunKamenyDolu();
                            PridejNoveKameny();
                            kamen1X = 0;
                            kamen1Y = 0;
                            kamen2X = 0;
                            kamen2Y = 0;
                        }
                        //if (ZjistiKonec() == 1) return;

                        clik1 = true;
                        NacteniPlochy(null, null);
                    }
                }
            }
        }

        private int VyhodnotTah()
        {
            int[,] novaTabulka = tabulka;
            int pomocBarva, lokalniBody = 0; ;
            bool dobryTah = false;
            pomocBarva = tabulka[kamen1X, kamen1Y];
            novaTabulka[kamen1X, kamen1Y] = tabulka[kamen2X, kamen2Y];
            novaTabulka[kamen2X, kamen2Y] = pomocBarva;

            //vodorovne
            for (int x = 0; x < 6; x++)
            {
                for (int y = 0; y < 8; y++)
                {
                    if (novaTabulka[x, y] == novaTabulka[x + 1, y] && novaTabulka[x + 1, y] == novaTabulka[x + 2, y])
                    {
                        if (dobryTah == false)
                        {
                            dobryTah = true;
                            if(!nechStarouTabulku) tabulka = novaTabulka;
                        }
                        lokalniBody += 3;
                        if (!nechStarouTabulku) tabulka[x, y] = 7;
                        if (!nechStarouTabulku) tabulka[x + 1, y] = 7;
                        if (!nechStarouTabulku) tabulka[x + 2, y] = 7;
                    }
                }
            }
            
            //svisle
            for (int x = 0; x < 8; x++)
            {
                for (int y = 0; y < 6; y++)
                {
                    if (novaTabulka[x, y] == novaTabulka[x, y + 1] && novaTabulka[x, y + 1] == novaTabulka[x, y + 2])
                    {
                        if (dobryTah == false)
                        {
                            dobryTah = true;
                            if (!nechStarouTabulku) tabulka = novaTabulka;
                        }
                        lokalniBody += 3;
                        if (!nechStarouTabulku) tabulka[x, y] = 7;
                        if (!nechStarouTabulku) tabulka[x, y + 1] = 7;
                        if (!nechStarouTabulku) tabulka[x, y + 2] = 7;
                    }
                }
            }
            celkoveBody += lokalniBody;
            return lokalniBody;
        }

        private void PosunKamenyDolu()
        {
            for (int i = 0; i < 9; i++) //aby spadly vsechny kameny
            {
                for (int x = 0; x < 8; x++)
                {
                    for (int y = 1; y < 8; y++)
                    {
                        if (tabulka[x, y] == 7)
                        {
                            tabulka[x, y] = tabulka[x, y - 1];
                            tabulka[x, y - 1] = 7;
                        }
                    }
                }
            }
        }
        
        private void PridejNoveKameny()
        {
            for (int x = 7; x >= 0; x--)
            {
                for (int y = 0; y < 8; y++)
                {
                    if (tabulka[x, y] == 7)
                    {
                        tabulka[x, y] = doplnovaci[y, poziceDopnovaci[y]];
                        poziceDopnovaci[y]++;
                        if (doplnovaci[y, poziceDopnovaci[y]] == 0) poziceDopnovaci[y] = 0;
                    }
                }
            }
        }

        private int ZjistiKonec()
        {
            int[,] zalohaTabulka = tabulka;

            nechStarouTabulku = true;

            for (int x = 0; x < 7; x++)
            {
                for (int y = 0; y < 8; y++)
                {
                    kamen1X = x;
                    kamen2X = x + 1;
                    kamen1Y = y;
                    kamen2X = y;
                    if (VyhodnotTah() > 0)
                    {
                        tabulka = zalohaTabulka;
                        nechStarouTabulku = false;
                        return 0;
                    }
                }
            }

            //svisle
            for (int x = 0; x < 8; x++)
            {
                for (int y = 0; y < 7; y++)
                {
                    kamen1X = x;
                    kamen2X = x;
                    kamen1Y = y;
                    kamen2X = y + 1;
                    if (VyhodnotTah() > 0)
                    {
                        tabulka = zalohaTabulka;
                        nechStarouTabulku = false;
                        return 0;
                    }
                }
            }
            Konec();
            return 1;
        }

        private void BTin_Click(object sender, EventArgs e)
        {
            BTin.Visible = false;
            BTstart.Visible = true;
            OpenFileDialog ofd = new OpenFileDialog();
            ofd.ShowDialog();
            this.File = ofd.FileName;

            DialogResult dr = MessageBox.Show("Chce časový limit? Pokud ano nastavte ho prosím nad tlačítkem start", "Časový limit", MessageBoxButtons.YesNo);

            if (dr == DialogResult.No) casovyLimit = false;
            else casovyLimit = true;

            StreamReader sr = new StreamReader(File);
            string[] radky = sr.ReadToEnd().Replace("\r", "").Split('\n');
            char[] radek = new char[1024];
            for (int y = 0; y < 8; y++)
            {
                radek = radky[y].ToCharArray();
                for (int x = 0; x < 8; x++) tabulka[x, y] = radek[x] - 48;
            }

            for (int x = 8; x < 15; x++)
            {
                radek = radky[x].ToCharArray();
                for (int y = 0; y < radky[9].ToCharArray().Length; y++) doplnovaci[x-8, y] = radek[y] - 48;
            }
            radky = null;
            radek = null;
            sr.Close();

            NacteniPlochy(null, null);
        }

        private static void OnTimedEvent(object source, ElapsedEventArgs e)
        {
            Konec();
        }

        private static void OnTimedEvent2(object source, ElapsedEventArgs e)
        {
            time += 1000;
        }

        public static void Konec()
        {
            MessageBox.Show("Konec hry stisknete OK pro novou hru");
            Thread.Sleep(1000);
            Application.Restart();
        }
    }
}
